/*
 * warning.c
 */
#include "copyright.h"

#include <stdio.h>
#include <math.h>
#include <signal.h>
#include "defs.h"
#include "struct.h"
#include "data.h"
#include "packets.h"

/*
** The warning in text will be printed in the warning window.
** The message will last WARNTIME/10 seconds unless another message
** comes through and overwrites it.
*/
warning(text)
char *text;
{
    struct warning_spacket warn;

    warn.type=SP_WARNING;
    strncpy(warn.mesg, text, 80);
    warn.mesg[79]='\0';
    sendClientPacket(&warn);
}
