#include <X11/Xlib.h>		/* ATM */
#include <stdio.h>
/*#include "/usr/att/usr/include/string.h"*/
#include <string.h>		/* ATM */
#include <sys/types.h>
#include <sys/time.h>
#include <signal.h>
#include <setjmp.h>
#include <sys/file.h>
#include <math.h>
#include <sys/ipc.h>
/*#include "/usr/att/usr/include/sys/shm.h"*/
#include <sys/shm.h>		/* ATM */
#include <errno.h>
#include <pwd.h>
#include <ctype.h>
#include "defs.h"
#include "struct.h"

struct status *status;
struct player *players;
struct player *me;
struct torp *torps;
struct ship *myship;
struct stats *mystats;
struct planet *planets;
struct phaser *phasers;
struct message *messages;
struct mctl *mctl;
struct team *teams;

openmem()
{
    extern int errno;
    int	shmemKey = PKEY;
    int	shmid;
    struct memory	*sharedMemory;

    errno = 0;
    shmid = shmget(shmemKey, 0, 0);
    if (shmid < 0) {
	if (errno != ENOENT) {
	    perror("shmget");
	    exit(1);
	}
	shmid = shmget(shmemKey, 0, 0);
	if (shmid < 0) {
	    fprintf(stderr, "Daemon not running\n");
	    exit (1);
	}
    }
    sharedMemory = (struct memory *) shmat(shmid, 0, 0);
    if (sharedMemory == (struct memory *) -1) {
	perror("shared memory");
	exit (1);
    }
    status = sharedMemory->status;
    players = sharedMemory->players;
    torps = sharedMemory->torps;
    planets = sharedMemory->planets;
    phasers = sharedMemory->phasers;
    mctl = sharedMemory->mctl;
    messages = sharedMemory->messages;
    teams = sharedMemory->teams;
}

main(argc, argv)
int argc;
char **argv;
{
    int i;
    int player;
    char buf[1000];

    openmem();
    player=atoi(argv[1]);
    players[player].p_ship.s_type = STARBASE;
    sprintf(buf, "GOD->ALL %s (%2s) was utterly obliterated.", 
      players[player].p_name, players[player].p_mapchars);
    pmessage(buf, 0, MALL);
    players[player].p_explode=10;
    players[player].p_status=3;
    players[player].p_whydead=KPROVIDENCE;
    players[player].p_whodead=0;
}

pmessage(str, recip, group)
char *str;
int recip;
int group;
{
    struct message *cur;
    if (++(mctl->mc_current) >= MAXMESSAGE)
	mctl->mc_current = 0;
    cur = &messages[mctl->mc_current];
    cur->m_no = mctl->mc_current;
    cur->m_flags = group;
    cur->m_time = 0;
    cur->m_recpt = recip;
    (void) sprintf(cur->m_data, "%s", str);
    cur->m_flags |= MVALID;
}
